## sumo 1.1.0+dfsg1

=== CMakeLists.txt ===
# Options
option(CHECK_OPTIONAL_LIBS "Try to download / enable all optional libraries (use only EPL clean libraries, if set to false)" true)
option(MULTITHREADED_BUILD "Use all available cores for building (applies to Visual Studio only)" true)
option(PROFILING "Enable output of profiling data (applies to gcc/clang builds only)" false)
option(COVERAGE "Enable output of coverage data (applies to gcc/clang builds only)" false)
set(BINARY_SUFFIX "" CACHE STRING "Append the suffix to every generated binary")

# Set a default build type if none was specified
# you may use -DCMAKE_BUILD_TYPE:STRING=Debug from the command line
set(default_build_type "Release")

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
  set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE
      STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release")
endif()

project(SUMO)
set(PACKAGE_VERSION "1.1.0")
cmake_minimum_required(VERSION 3.1)
# do not expand quoted variables in if statements
cmake_policy(SET CMP0054 NEW)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/build/cmake_modules/")

set(ENABLED_FEATURES "${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR} ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}")

# compiler specific flags
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
        "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -pedantic -Wextra")
    set(ENABLED_FEATURES "${ENABLED_FEATURES} ${CMAKE_BUILD_TYPE}")
    if (PROFILING)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
        set(ENABLED_FEATURES "${ENABLED_FEATURES} Profiling")
        set(BINARY_SUFFIX "${BINARY_SUFFIX}P")
    endif ()
    if (COVERAGE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage -O0")
        set(ENABLED_FEATURES "${ENABLED_FEATURES} Coverage")
    endif ()
elseif (MSVC)
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /W3")
    # set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /W4 /WX /EHsc")
    # enabling /WX is not possible due to warnings in external headers
    # /Wall brings MSVC to complete halt
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /W4 /EHsc")
    if (MULTITHREADED_BUILD)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
    endif ()
endif ()

# special debug flags
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG")
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -stdlib=libstdc++ -fsanitize=undefined,address,integer,unsigned-integer-overflow -fno-omit-frame-pointer -fsanitize-blacklist=${CMAKE_SOURCE_DIR}/build/clang_sanitize_blacklist.txt")
endif ()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)
# force Visual Studio to leave out the Release / Debug dirs
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_SOURCE_DIR}/bin)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_SOURCE_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG ${CMAKE_SOURCE_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE ${CMAKE_SOURCE_DIR}/bin)
# Debug messages
message(STATUS "CMAKE_BINARY_DIR: " ${CMAKE_BINARY_DIR})
message(STATUS "CMAKE_SOURCE_DIR: " ${CMAKE_SOURCE_DIR})
message(STATUS "")
message(STATUS "Platform: ")
message(STATUS "    Host: " ${CMAKE_HOST_SYSTEM} " " ${CMAKE_HOST_SYSTEM_PROCESSOR})
message(STATUS "    Target: " ${CMAKE_SYSTEM} " " ${CMAKE_SYSTEM_PROCESSOR})
message(STATUS "    CMake: " ${CMAKE_VERSION})
message(STATUS "    CMake generator: " ${CMAKE_GENERATOR})
message(STATUS "    CMake build tool: " ${CMAKE_BUILD_TOOL})
message(STATUS "    Compiler: " ${CMAKE_CXX_COMPILER_ID} " " ${CMAKE_CXX_COMPILER_VERSION})
if (CMAKE_GENERATOR MATCHES Xcode)
    message(STATUS "    Xcode: " ${XCODE_VERSION})
endif ()
message(STATUS "")

#set(Python_ADDITIONAL_VERSIONS 3.7 3.6 3.5 3.4 3.3 2.7) # it may help in finding the correct python for libsumo
find_package(PythonInterp REQUIRED)
message(STATUS "Found Python: " ${PYTHON_EXECUTABLE})

#http://stackoverflow.com/questions/1487752/how-do-i-instruct-cmake-to-look-for-libraries-installed-by-macports
if (APPLE)
    link_directories(/opt/X11/lib)
    include_directories(/opt/X11/include)
    # Detect if the "port" command is valid on this system; if so, return full path
    execute_process(COMMAND which port RESULT_VARIABLE DETECT_MACPORTS OUTPUT_VARIABLE MACPORTS_PREFIX ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
    if (${DETECT_MACPORTS} EQUAL 0)
        # MACPORTS_PREFIX contains now something like "/opt/local/bin/port", so we get the parent directory
        get_filename_component(MACPORTS_PREFIX ${MACPORTS_PREFIX} DIRECTORY)
        # "/opt/local" is where MacPorts lives, add `/lib` suffix and link
        link_directories(${MACPORTS_PREFIX}/../lib)
        include_directories(${MACPORTS_PREFIX}/../include)
        message(STATUS "Macports detected: ${MACPORTS_PREFIX}")
    endif ()
    # Recommendation, also add a "brew --prefix" custom command to detect a homebrew build environment
    execute_process(COMMAND brew --prefix RESULT_VARIABLE DETECT_BREW OUTPUT_VARIABLE BREW_PREFIX ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
    if (${DETECT_BREW} EQUAL 0)
        link_directories(${BREW_PREFIX}/lib)
        include_directories(${BREW_PREFIX}/include)
        message(STATUS "Brew detected: ${BREW_PREFIX}")
    endif ()
endif (APPLE)

#  Specifically define variable WIN32 for compilations under windows (due an error in Shawn)
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" AND WIN32)
    option(USE_MINGW_64BITS "Use 64 bits libraries for the compilation with MinGW" true)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DWIN32 -D_WIN32_WINNT=0x0501")
endif ()

# Check if libraries have to be found, depending on SUMO_LIBRARIES
set(SUMO_LIBRARIES "$ENV{SUMO_LIBRARIES}" CACHE PATH "Location of SUMOLibraries dependencies")
if (NOT SUMO_LIBRARIES AND EXISTS "${CMAKE_SOURCE_DIR}/../SUMOLibraries")
    set(SUMO_LIBRARIES "${CMAKE_SOURCE_DIR}/../SUMOLibraries")
endif ()
if (SUMO_LIBRARIES)
    # Special option for MinGW32
    if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" AND WIN32)
        if(USE_MINGW_64BITS)
            message(STATUS "Using 64 bit libraries from SUMO_LIBRARIES placed in " ${SUMO_LIBRARIES} " for MinGW compilation")
            set(LIB_VERSION "_64")
        else()
            message(STATUS "Using 32 bit libraries from SUMO_LIBRARIES placed in " ${SUMO_LIBRARIES} " for MinGW compilation")
            set(CHECK_OPTIONAL_LIBS false)
        endif()
    elseif(${CMAKE_MODULE_LINKER_FLAGS} STREQUAL "/machine:x64")
        message(STATUS "Using 64 bit libraries from SUMO_LIBRARIES placed in " ${SUMO_LIBRARIES})
        set(LIB_VERSION "_64")
    else()
        message(STATUS "Using 32 bit libraries from SUMO_LIBRARIES placed in " ${SUMO_LIBRARIES})
        set(CHECK_OPTIONAL_LIBS false)
    endif()
    if("${MSVC_VERSION}" STREQUAL "1800")
        file(GLOB XERCES_PATH "${SUMO_LIBRARIES}/msvc12/xerces-c-3.?.?${LIB_VERSION}")
    else()
        file(GLOB XERCES_PATH "${SUMO_LIBRARIES}/xerces-c-3.?.?${LIB_VERSION}")
    endif()
    file(GLOB PROJ_PATH "${SUMO_LIBRARIES}/proj_gdal-????${LIB_VERSION}")
    file(GLOB FOX_PATH "${SUMO_LIBRARIES}/fox-1.6.??${LIB_VERSION}")
    set(CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH};${XERCES_PATH};${PROJ_PATH};${FOX_PATH}")
    file(GLOB SUMO_LIBRARIES_DLL "${XERCES_PATH}/bin/*.dll"
                                 "${PROJ_PATH}/bin/*.dll"
                                 "${FOX_PATH}/lib/*.dll"
                                 "${SUMO_LIBRARIES}/3rdPartyLibs/bzip2-?.?.?${LIB_VERSION}/*.dll"
                                 "${SUMO_LIBRARIES}/3rdPartyLibs/libpng-?.?.??${LIB_VERSION}/*/*.dll"
                                 "${SUMO_LIBRARIES}/3rdPartyLibs/tiff-?.?.?${LIB_VERSION}/libtiff/*/*.dll"
                                 "${SUMO_LIBRARIES}/3rdPartyLibs/zlib-?.?.??${LIB_VERSION}/*/*.dll")
    # set GoogleTest only if compiler isn't mingw32
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" AND WIN32)
        if(USE_MINGW_64BITS)
            # Prevent GoogleTest from overriding our compiler/linker options
            set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
            add_subdirectory("${SUMO_LIBRARIES}/googletest-1.8.0/googletest"
                             "${CMAKE_BINARY_DIR}/googletest-build")
            include_directories("${SUMO_LIBRARIES}/googletest-1.8.0/googletest/include")
            set(GTEST_BOTH_LIBRARIES "gtest" "gtest_main")
            set(GTEST_FOUND true)
        else()
            message(STATUS "Disabled Google Test in Mingw32")
        endif()
    endif()
    file(GLOB FFMPEG_PATH "${SUMO_LIBRARIES}/FFMPEG-?.?.?${LIB_VERSION}")
    file(GLOB OSG_PATH "${SUMO_LIBRARIES}/OSG-?.?.?${LIB_VERSION}")
    if("${MSVC_VERSION}" STREQUAL "1800")
        file(GLOB GL2PS_PATH "${SUMO_LIBRARIES}/msvc12/gl2ps-?.?.?${LIB_VERSION}")
    else()
        file(GLOB GL2PS_PATH "${SUMO_LIBRARIES}/gl2ps-?.?.?${LIB_VERSION}")
    endif()
    set(CMAKE_LIBRARY_PATH "${CMAKE_LIBRARY_PATH};${GL2PS_PATH}/Release")
    set(CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH};${FFMPEG_PATH};${OSG_PATH};${GL2PS_PATH}")
    file(GLOB SUMO_OPTIONAL_LIBRARIES_DLL "${FFMPEG_PATH}/bin/*.dll" "${GL2PS_PATH}/Release/*.dll")
    # set SWIG
    set(SWIG_EXECUTABLE "${SUMO_LIBRARIES}/swigwin-3.0.12/swig.exe")
    # set GRPC
    set(CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH};${SUMO_LIBRARIES}/grpc-1.10.0${LIB_VERSION}")
    set(CMAKE_LIBRARY_PATH "${CMAKE_LIBRARY_PATH};${SUMO_LIBRARIES}/grpc-1.10.0${LIB_VERSION}/Debug")
    set(CMAKE_LIBRARY_PATH "${CMAKE_LIBRARY_PATH};${SUMO_LIBRARIES}/grpc-1.10.0${LIB_VERSION}/Release")
    set(GRPC_CPP_PLUGIN "${SUMO_LIBRARIES}/grpc-1.10.0${LIB_VERSION}/Release/grpc_cpp_plugin.exe")
    # set protobuf
    set(CMAKE_PREFIX_PATH "${CMAKE_PREFIX_PATH};${SUMO_LIBRARIES}/3rdPartyLibs/protobuf-3.5.1${LIB_VERSION}")
    set(Protobuf_PROTOC_EXECUTABLE "${SUMO_LIBRARIES}/3rdPartyLibs/protobuf-3.5.1${LIB_VERSION}/cmake/Release/protoc.exe")
    set(Protobuf_LIBRARY_DEBUG "${CMAKE_LIBRARY_PATH};${SUMO_LIBRARIES}/protobuf-3.5.1${LIB_VERSION}/cmake/Debug/libprotobufd.lib")
    set(Protobuf_LIBRARY "${CMAKE_LIBRARY_PATH};${SUMO_LIBRARIES}/protobuf-3.5.1${LIB_VERSION}/cmake/Release/libprotobuf.lib")
else (SUMO_LIBRARIES)
    # for Linux and Mac only
    find_package(GTest)
endif (SUMO_LIBRARIES)

find_package(XercesC REQUIRED)
if (XercesC_FOUND)
    include_directories(${XercesC_INCLUDE_DIRS})
endif (XercesC_FOUND)

find_package(Proj)
if (PROJ_FOUND)
    include_directories(${PROJ_INCLUDE_DIR})
    set(HAVE_PROJ 1)
    set(ENABLED_FEATURES "${ENABLED_FEATURES} Proj")
endif (PROJ_FOUND)

find_package(FOX)
if (FOX_FOUND)
    include_directories(${FOX_INCLUDE_DIR})
    add_definitions(${FOX_CXX_FLAGS})
    add_definitions(-DFLOAT_MATH_FUNCTIONS)
    set(HAVE_FOX 1)
    set(ENABLED_FEATURES "${ENABLED_FEATURES} GUI")
endif (FOX_FOUND)

find_package(X11)
if (X11_FOUND)
    link_directories(${X11_LIBRARY_DIR})
    include_directories(${X11_INCLUDE_DIR})
endif (X11_FOUND)

if (CHECK_OPTIONAL_LIBS)
    find_package(GDAL)
    if (GDAL_FOUND)
        include_directories(${GDAL_INCLUDE_DIR})
        set(HAVE_GDAL 1)
        set(ENABLED_FEATURES "${ENABLED_FEATURES} GDAL")
    endif (GDAL_FOUND)

    find_package(FFMPEG)
    if (FFMPEG_FOUND)
        include_directories(${FFMPEG_INCLUDE_DIR})
        set(HAVE_FFMPEG 1)
        set(ENABLED_FEATURES "${ENABLED_FEATURES} FFmpeg")
    endif ()

    find_package(OpenSceneGraph 3.4.0 COMPONENTS osgGA osgViewer osgUtil osgDB osgText)
    if (OPENSCENEGRAPH_FOUND)
        include_directories(${OPENSCENEGRAPH_INCLUDE_DIRS})
        set(HAVE_OSG 1)

=== src/CMakeLists.txt ===
set(netconvertlibs
        netwrite netimport netbuild foreign_eulerspiral ${GDAL_LIBRARY} netimport_vissim netimport_vissim_typeloader netimport_vissim_tempstructs ${commonlibs})

set(sumolibs
        traciserver libsumostatic netload microsim_cfmodels microsim_lcmodels microsim_devices microsim_trigger microsim_output microsim_pedestrians microsim_actions
        microsim_traffic_lights microsim mesosim ${commonvehiclelibs} ${GRPC_LIBS}
        ${PYTHON_LIBRARIES})

add_subdirectory(activitygen)
add_subdirectory(dfrouter)
add_subdirectory(duarouter)
add_subdirectory(foreign)
add_subdirectory(jtrrouter)
add_subdirectory(libsumo)
add_subdirectory(marouter)
add_subdirectory(mesosim)
add_subdirectory(microsim)
add_subdirectory(netbuild)
add_subdirectory(netgen)
add_subdirectory(netimport)
add_subdirectory(netload)
add_subdirectory(netwrite)
add_subdirectory(od)
add_subdirectory(osgview)
add_subdirectory(polyconvert)
add_subdirectory(router)
add_subdirectory(tools)
add_subdirectory(traci-server)
add_subdirectory(traci_testclient)
add_subdirectory(utils)
if (FOX_FOUND)
    add_subdirectory(gui)
    add_subdirectory(guinetload)
    add_subdirectory(guisim)
    add_subdirectory(mesogui)
    add_subdirectory(netedit)
endif ()


add_executable(sumo sumo_main.cpp)
set_target_properties(sumo PROPERTIES OUTPUT_NAME sumo${BINARY_SUFFIX})
set_target_properties(sumo PROPERTIES OUTPUT_NAME_DEBUG sumo${BINARY_SUFFIX}D)
target_link_libraries(sumo microsim ${sumolibs})
add_dependencies(sumo generate-version-h)

if (FOX_FOUND)
    add_executable(sumo-gui guisim_main.cpp sumo-gui.rc)
    set_target_properties(sumo-gui PROPERTIES OUTPUT_NAME sumo-gui${BINARY_SUFFIX})
    set_target_properties(sumo-gui PROPERTIES OUTPUT_NAME_DEBUG sumo-gui${BINARY_SUFFIX}D)
    target_link_libraries(sumo-gui gui guinetload guisim gui gui_dialogs
        utils_gui_windows utils_gui_globjects utils_gui_div utils_gui_settings
        utils_gui_images utils_gui_cursors utils_gui_tracker utils_foxtools osgview microsim ${sumolibs} mesogui
        ${GDAL_LIBRARY} ${FFMPEG_LIBRARIES} ${OPENSCENEGRAPH_LIBRARIES} ${GL2PS_LIBRARIES})
    if (MSVC)
        set_target_properties(sumo-gui PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:WINDOWS /ENTRY:mainCRTStartup")
        if (FFMPEG_FOUND)
            set_target_properties(sumo-gui PROPERTIES LINK_FLAGS "/SAFESEH:NO")
        endif ()
        target_link_libraries(sumo-gui opengl32 glu32)
    endif ()
    add_dependencies(sumo-gui generate-version-h)
    install(TARGETS sumo-gui RUNTIME DESTINATION bin)
endif ()

add_executable(netconvert netconvert_main.cpp)
set_target_properties(netconvert PROPERTIES OUTPUT_NAME netconvert${BINARY_SUFFIX})
set_target_properties(netconvert PROPERTIES OUTPUT_NAME_DEBUG netconvert${BINARY_SUFFIX}D)
target_link_libraries(netconvert ${netconvertlibs})
add_dependencies(netconvert generate-version-h)

add_executable(od2trips od2trips_main.cpp)
set_target_properties(od2trips PROPERTIES OUTPUT_NAME od2trips${BINARY_SUFFIX})
set_target_properties(od2trips PROPERTIES OUTPUT_NAME_DEBUG od2trips${BINARY_SUFFIX}D)
target_link_libraries(od2trips od utils_vehicle ${commonlibs})
add_dependencies(od2trips generate-version-h)

install(TARGETS sumo netconvert od2trips RUNTIME DESTINATION bin)

configure_file(config.h.cmake config.h)

add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/src/version.h
                   COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tools/build/version.py ${CMAKE_BINARY_DIR}/src
                  )
add_custom_target(generate-version-h
                  DEPENDS ${CMAKE_BINARY_DIR}/src/version.h
                 )
set_property(TARGET generate-version-h PROPERTY FOLDER "CMake") 

set_source_files_properties(${CMAKE_BINARY_DIR}/src/version.h
    PROPERTIES GENERATED TRUE)

=== src/activitygen/CMakeLists.txt ===
add_subdirectory(activities)
add_subdirectory(city)

set(activitygen_SRCS
   activitygen_main.cpp
   AGActivityGen.cpp
   AGActivityGen.h
   AGActivityGenHandler.cpp
   AGActivityGenHandler.h
   AGActivityTripWriter.cpp
   AGActivityTripWriter.h
   AGFrame.cpp
   AGFrame.h
)

add_executable(activitygen ${activitygen_SRCS})
set_target_properties(activitygen PROPERTIES OUTPUT_NAME activitygen${BINARY_SUFFIX})
set_target_properties(activitygen PROPERTIES OUTPUT_NAME_DEBUG activitygen${BINARY_SUFFIX}D)
target_link_libraries(activitygen activitygen_activities activitygen_city router ${commonvehiclelibs})
add_dependencies(activitygen generate-version-h)

install(TARGETS activitygen RUNTIME DESTINATION bin)

=== src/duarouter/CMakeLists.txt ===
set(duarouter_SRCS
   duarouter_main.cpp
   RODUAEdgeBuilder.cpp
   RODUAEdgeBuilder.h
   RODUAFrame.cpp
   RODUAFrame.h
)

add_executable(duarouter ${duarouter_SRCS})
set_target_properties(duarouter PROPERTIES OUTPUT_NAME duarouter${BINARY_SUFFIX})
set_target_properties(duarouter PROPERTIES OUTPUT_NAME_DEBUG duarouter${BINARY_SUFFIX}D)
target_link_libraries(duarouter router ${commonvehiclelibs})
add_dependencies(duarouter generate-version-h)

install(TARGETS duarouter RUNTIME DESTINATION bin)

=== src/libsumo/CMakeLists.txt ===
set(libsumostatic_STAT_SRCS
        Helper.cpp
        Helper.h
        InductionLoop.cpp
        InductionLoop.h
        Junction.cpp
        Junction.h
        Lane.cpp
        Lane.h
        LaneArea.cpp
        LaneArea.h
        MultiEntryExit.h
        MultiEntryExit.cpp
        Person.cpp
        Person.h
        POI.cpp
        POI.h
        Polygon.h
        Polygon.cpp
        Route.h
        Route.cpp
        Simulation.cpp
        Simulation.h
        Subscription.h
        TraCIDefs.h
        TrafficLight.cpp
        TrafficLight.h
        Vehicle.h
        Vehicle.cpp
        VehicleType.cpp
        VehicleType.h
        Edge.cpp Edge.h)

add_library(libsumostatic STATIC ${libsumostatic_STAT_SRCS})
set_property(TARGET libsumostatic PROPERTY FOLDER "libsumo")

set(ENABLE_PYTHON_BINDINGS ON CACHE BOOL "Build Python Bindings")
set(ENABLE_JAVA_BINDINGS ON CACHE BOOL "Build Java Bindings")

if(SWIG_FOUND)
    include(${SWIG_USE_FILE})
    set_source_files_properties(libsumo.i PROPERTIES CPLUSPLUS ON)
    file(GLOB LIBSUMO_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
    if(ENABLE_JAVA_BINDINGS)
        find_package(Java)
        find_package(JNI)
        if(JAVA_FOUND AND JNI_FOUND)
            include(UseJava)
            include_directories(${JNI_INCLUDE_DIRS})
            set(CMAKE_SWIG_FLAGS -package org.eclipse.sumo.libsumo)
            set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR}/java)
            set(SWIG_MODULE_libsumojni_EXTRA_DEPS ${LIBSUMO_HEADERS})
            if (${CMAKE_VERSION} VERSION_GREATER 3.8.0)
                SWIG_ADD_LIBRARY(libsumojni LANGUAGE java SOURCES libsumo.i)
            else()
                SWIG_ADD_MODULE(libsumojni java libsumo.i)
            endif()
            if (MSVC OR APPLE)
                swig_link_libraries(libsumojni ${sumolibs})
            else()
                set_source_files_properties(${swig_generated_file_fullname} PROPERTIES COMPILE_FLAGS "-Wno-strict-aliasing")
                swig_link_libraries(libsumojni -Wl,--whole-archive ${sumolibs} -Wl,--no-whole-archive)
            endif()
            FILE(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/classes")
            ADD_CUSTOM_COMMAND(TARGET libsumojni POST_BUILD
                COMMAND "${Java_JAVAC_EXECUTABLE}" -d classes java/*.java
                COMMAND "${Java_JAR_EXECUTABLE}" -cfM ${CMAKE_SOURCE_DIR}/bin/libsumojni.jar -C classes .
                COMMAND "${Java_JAR_EXECUTABLE}" -cfM ${CMAKE_SOURCE_DIR}/bin/libsumojni_src.jar -C java .
            )
            set_property(TARGET libsumojni PROPERTY FOLDER "libsumo")
        else()
            message(WARNING "ENABLE_JAVA_BINDINGS is set but Java or JNI was not found.")
        endif()
    endif()

    find_package(PythonLibs)
    if(ENABLE_PYTHON_BINDINGS)
        if (MSVC)
            # recheck that the platform of the generator and python matches
            execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "import sys; print(sys.version)"
                            OUTPUT_VARIABLE PYTHON_FULL_VERSION OUTPUT_STRIP_TRAILING_WHITESPACE)
            string(FIND ${PYTHON_FULL_VERSION} "64 bit" IS_PYTHON64)
            if(${CMAKE_MODULE_LINKER_FLAGS} STREQUAL "/machine:x64" AND ${IS_PYTHON64} EQUAL -1)
                message(STATUS "Did not find Python 64 bit. Please set PYTHON_EXECUTABLE, PYTHON_INCLUDE_DIR and PYTHON_LIBRARY manually.")
                set(PYTHONLIBS_FOUND OFF)
            endif()
        endif()
        if(PYTHONLIBS_FOUND)
            include_directories(${PYTHON_INCLUDE_PATH})
#            set(CMAKE_SWIG_FLAGS "")
            set(CMAKE_SWIG_FLAGS "-keyword") # is necessary for using keyword args, but generates lots of warnings
# other options which should be evaluated: -builtin, -modern, -extranative
            set(CMAKE_SWIG_OUTDIR ${CMAKE_SOURCE_DIR}/tools/libsumo)
            set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/tools/libsumo)
            set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG ${CMAKE_SOURCE_DIR}/tools/libsumo)
            set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE ${CMAKE_SOURCE_DIR}/tools/libsumo)
            set(SWIG_MODULE_libsumo_EXTRA_DEPS ${LIBSUMO_HEADERS})
            if (${CMAKE_VERSION} VERSION_GREATER 3.8.0)
                SWIG_ADD_LIBRARY(libsumo LANGUAGE python SOURCES libsumo.i)
            else()
                SWIG_ADD_MODULE(libsumo python libsumo.i)
            endif()
            if (MSVC OR APPLE)
                # disable python module for the debug build because virtually no one has a python debug dll to link against
                set_property(TARGET ${SWIG_MODULE_libsumo_REAL_NAME} PROPERTY EXCLUDE_FROM_DEFAULT_BUILD_DEBUG TRUE)
                set_property(TARGET ${SWIG_MODULE_libsumo_REAL_NAME} PROPERTY FOLDER "libsumo")
                swig_link_libraries(libsumo ${sumolibs} ${PYTHON_LIBRARIES})
            else()
                swig_link_libraries(libsumo -Wl,--whole-archive ${sumolibs} -Wl,--no-whole-archive ${PYTHON_LIBRARIES})
            endif()
            install(
                CODE "execute_process(COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tools/build/setup-libsumo.py clean --all install --prefix $ENV{DESTDIR}${CMAKE_INSTALL_PREFIX})"
                COMPONENT pylibsumo)
        else()
            message(WARNING "ENABLE_PYTHON_BINDINGS is set but python libraries were not found.")
        endif()
    endif()

endif()

=== src/microsim/CMakeLists.txt ===
add_subdirectory(actions)
add_subdirectory(cfmodels)
add_subdirectory(devices)
add_subdirectory(lcmodels)
add_subdirectory(logging)
add_subdirectory(output)
add_subdirectory(pedestrians)
add_subdirectory(traffic_lights)
add_subdirectory(trigger)

set(microsim_STAT_SRCS
   MSBitSetLogic.h
   MSBaseVehicle.cpp
   MSBaseVehicle.h
   MSCModel_NonInteracting.h
   MSCModel_NonInteracting.cpp
   MSContainer.cpp
   MSContainer.h
   MSEdge.cpp
   MSEdge.h
   MSEdgeControl.cpp
   MSEdgeControl.h
   MSEdgeWeightsStorage.cpp
   MSEdgeWeightsStorage.h
   MSEventControl.cpp
   MSEventControl.h
   MSFrame.cpp
   MSFrame.h
   MSGlobals.cpp
   MSGlobals.h
   MSInsertionControl.cpp
   MSInsertionControl.h
   MSInternalJunction.cpp
   MSInternalJunction.h
   MSJunction.cpp
   MSJunction.h
   MSJunctionControl.cpp
   MSJunctionControl.h
   MSJunctionLogic.cpp
   MSJunctionLogic.h
   MSLane.cpp
   MSLane.h
   MSLaneChanger.cpp
   MSLaneChanger.h
   MSLaneChangerSublane.cpp
   MSLaneChangerSublane.h
   MSLink.cpp
   MSLink.h
   MSLinkCont.cpp
   MSLinkCont.h
   MSLogicJunction.cpp
   MSLogicJunction.h
   MSMoveReminder.cpp
   MSMoveReminder.h
   MSNet.cpp
   MSNet.h
   MSNoLogicJunction.cpp
   MSNoLogicJunction.h
   MSRightOfWayJunction.cpp
   MSRightOfWayJunction.h
   MSRoute.cpp
   MSRoute.h
   MSRouteHandler.cpp
   MSRouteHandler.h
   MSStoppingPlace.cpp
   MSStoppingPlace.h
   MSParkingArea.cpp
   MSParkingArea.h
   MSVehicle.cpp
   MSVehicle.h
   MSLeaderInfo.cpp
   MSLeaderInfo.h
   MSVehicleContainer.cpp
   MSVehicleContainer.h
   MSVehicleControl.cpp
   MSVehicleControl.h
   MSVehicleTransfer.cpp
   MSVehicleTransfer.h
   MSVehicleType.cpp
   MSVehicleType.h
   MSStateHandler.h
   MSStateHandler.cpp
   MSDriverState.h
   MSDriverState.cpp
   MSTransportable.h
   MSTransportable.cpp
   MSTransportableControl.h
   MSTransportableControl.cpp
)

add_library(microsim STATIC ${microsim_STAT_SRCS})
add_dependencies(microsim generate-version-h)
set_property(TARGET microsim PROPERTY PROJECT_LABEL "z_microsim")

=== src/netedit/CMakeLists.txt ===
add_subdirectory(additionals)
add_subdirectory(changes)
add_subdirectory(dialogs)
add_subdirectory(frames)
add_subdirectory(netelements)

set(netedit_SRCS
   netedit_main.cpp
   GNEApplicationWindow.h
   GNEApplicationWindow.cpp
   GNELoadThread.h
   GNELoadThread.cpp
   GNENet.h
   GNENet.cpp
   GNEViewNet.h
   GNEViewNet.cpp
   GNEViewParent.h
   GNEViewParent.cpp
   GNEUndoList.h
   GNEUndoList.cpp
   GNEAttributeCarrier.h
   GNEAttributeCarrier.cpp
   GNEReferenceCounter.h
   GNEEvent_NetworkLoaded.h
)

add_executable(netedit ${netedit_SRCS} netedit.rc)
set_target_properties(netedit PROPERTIES OUTPUT_NAME netedit${BINARY_SUFFIX})
set_target_properties(netedit PROPERTIES OUTPUT_NAME_DEBUG netedit${BINARY_SUFFIX}D)
target_link_libraries(netedit utils_gui_windows utils_gui_globjects utils_gui_div utils_gui_settings utils_gui_images utils_gui_cursors utils_gui_tracker
        utils_foxtools foreign_eulerspiral netedit_frames netedit_changes netedit_netelements netedit_additionals netedit_dialogs utils_gui_windows utils_foxtools ${netconvertlibs} ${FOX_LIBRARY} ${GL2PS_LIBRARIES})
if (MSVC)
    set_target_properties(netedit PROPERTIES LINK_FLAGS_RELEASE "/SUBSYSTEM:WINDOWS /ENTRY:mainCRTStartup")
    target_link_libraries(netedit opengl32 glu32)
endif ()
add_dependencies(netedit generate-version-h)

install(TARGETS netedit RUNTIME DESTINATION bin)

=== src/netgen/CMakeLists.txt ===
set(netgenerate_SRCS
   netgen_main.cpp
   NGEdge.cpp
   NGEdge.h
   NGFrame.cpp
   NGFrame.h
   NGNet.h
   NGNet.cpp
   NGNode.cpp
   NGNode.h
   NGRandomNetBuilder.h
   NGRandomNetBuilder.cpp
)

add_executable(netgenerate ${netgenerate_SRCS})
set_target_properties(netgenerate PROPERTIES OUTPUT_NAME netgenerate${BINARY_SUFFIX})
set_target_properties(netgenerate PROPERTIES OUTPUT_NAME_DEBUG netgenerate${BINARY_SUFFIX}D)
target_link_libraries(netgenerate netbuild netwrite ${GDAL_LIBRARY} ${commonlibs})
add_dependencies(netgenerate generate-version-h)

install(TARGETS netgenerate RUNTIME DESTINATION bin)

=== src/netimport/CMakeLists.txt ===
add_subdirectory(vissim)

set(netimport_STAT_SRCS
   NIFrame.cpp
   NIFrame.h
   NILoader.cpp
   NILoader.h
   NIImporter_ArcView.cpp
   NIImporter_ArcView.h
   NIImporter_DlrNavteq.cpp
   NIImporter_DlrNavteq.h
   NIImporter_ITSUMO.cpp
   NIImporter_ITSUMO.h
   NIImporter_MATSim.cpp
   NIImporter_MATSim.h
   NIImporter_OpenDrive.cpp
   NIImporter_OpenDrive.h
   NIImporter_OpenStreetMap.cpp
   NIImporter_OpenStreetMap.h
   NIImporter_RobocupRescue.cpp
   NIImporter_RobocupRescue.h
   NIImporter_SUMO.cpp
   NIImporter_SUMO.h
   NIImporter_VISUM.cpp
   NIImporter_VISUM.h
   NIVisumTL.cpp
   NIVisumTL.h
   NIXMLConnectionsHandler.cpp
   NIXMLConnectionsHandler.h
   NIXMLEdgesHandler.cpp
   NIXMLEdgesHandler.h
   NIXMLNodesHandler.cpp
   NIXMLNodesHandler.h
   NIXMLTypesHandler.cpp
   NIXMLTypesHandler.h
   NIXMLPTHandler.cpp
   NIXMLPTHandler.h
   NIXMLTrafficLightsHandler.cpp
   NIXMLTrafficLightsHandler.h
   NINavTeqHelper.cpp
   NINavTeqHelper.h
   typemap.h
)

add_library(netimport STATIC ${netimport_STAT_SRCS})
set_property(TARGET netimport PROPERTY PROJECT_LABEL "z_netimport")

add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/src/netimport/typemap.h
                   COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../../tools/build/typemap.py ${CMAKE_BINARY_DIR}/src
                   )
#add_custom_target(generate-typemap-h DEPENDS ${CMAKE_BINARY_DIR}/src/netimport/typemap.h)
#set_property(TARGET generate-typemap-h PROPERTY FOLDER "CMake") 
set_source_files_properties(${CMAKE_BINARY_DIR}/src/netimport/typemap.h PROPERTIES GENERATED TRUE)

=== src/osgview/CMakeLists.txt ===

########### next target ###############

SET(osgview_STAT_SRCS
   GUIOSGBoundingBoxCalculator.h
   GUIOSGBuilder.cpp
   GUIOSGBuilder.h
   GUIOSGView.cpp
   GUIOSGView.h
)

add_library(osgview STATIC ${osgview_STAT_SRCS})
set_property(TARGET osgview PROPERTY PROJECT_LABEL "z_osgview")


########### install files ###############




#original Makefile.am contents follow:

#noinst_LIBRARIES = libosgview.a
#
#libosgview_a_SOURCES = GUIOSGBoundingBoxCalculator.h \
#GUIOSGBuilder.cpp GUIOSGBuilder.h \
#GUIOSGView.cpp GUIOSGView.h

=== src/traci-server/CMakeLists.txt ===
SET(traciserver_STAT_SRCS
   TraCIConstants.h
   TraCIServer.h
   TraCIServer.cpp
   TraCIServerAPI_Edge.h
   TraCIServerAPI_Edge.cpp
   TraCIServerAPI_InductionLoop.h
   TraCIServerAPI_InductionLoop.cpp
   TraCIServerAPI_Junction.h
   TraCIServerAPI_Junction.cpp
   TraCIServerAPI_Lane.h
   TraCIServerAPI_Lane.cpp
   TraCIServerAPI_MultiEntryExit.h
   TraCIServerAPI_MultiEntryExit.cpp
   TraCIServerAPI_LaneArea.h
   TraCIServerAPI_LaneArea.cpp
   TraCIServerAPI_Person.h
   TraCIServerAPI_Person.cpp
   TraCIServerAPI_POI.h
   TraCIServerAPI_POI.cpp
   TraCIServerAPI_Polygon.h
   TraCIServerAPI_Polygon.cpp
   TraCIServerAPI_Route.h
   TraCIServerAPI_Route.cpp
   TraCIServerAPI_Simulation.h
   TraCIServerAPI_Simulation.cpp
   TraCIServerAPI_TrafficLight.h
   TraCIServerAPI_TrafficLight.cpp
   TraCIServerAPI_Vehicle.h
   TraCIServerAPI_Vehicle.cpp
   TraCIServerAPI_VehicleType.h
   TraCIServerAPI_VehicleType.cpp
)

add_library(traciserver STATIC ${traciserver_STAT_SRCS})
set_property(TARGET traciserver PROPERTY PROJECT_LABEL "z_traciserver")
add_dependencies(traciserver generate-version-h)

=== src/traci_testclient/CMakeLists.txt ===
set(TraCITestClient_SRCS
   tracitestclient_main.cpp
   TraCITestClient.cpp
   TraCITestClient.h
)

add_executable(TraCITestClient ${TraCITestClient_SRCS})
set_target_properties(TraCITestClient PROPERTIES OUTPUT_NAME TraCITestClient${BINARY_SUFFIX})
set_target_properties(TraCITestClient PROPERTIES OUTPUT_NAME_DEBUG TraCITestClient${BINARY_SUFFIX}D)
target_link_libraries(TraCITestClient utils_traci ${commonlibs})

add_executable(testlibsumo testlibsumo_main.cpp)
set_target_properties(testlibsumo PROPERTIES OUTPUT_NAME testlibsumo${BINARY_SUFFIX})
set_target_properties(testlibsumo PROPERTIES OUTPUT_NAME_DEBUG testlibsumo${BINARY_SUFFIX}D)
target_link_libraries(testlibsumo ${sumolibs} traciserver microsim_cfmodels microsim_devices microsim_lcmodels microsim_output)

=== debian/changelog ===
sumo (1.1.0+dfsg1-1) unstable; urgency=medium

  [ Michael Behrisch ]
  * [b063b03] Update d/copyright

  [ Anton Gladky ]
  * [a9773da] Update patches
  * [d520897] Use libxerces-c2-dev as build-depends
  * [88bcbf6] Update install files
  * [e0d8261] Use compat-level 11
  * [23d078f] Remove some files from the source
  * [2372382] Minor fixes
  * [cc81cb9] Trim trailing whitespace.
  * [c2b2305] Use secure copyright file specification URI.
  * [14aae51] Drop unnecessary dependency on dh-autoconf.
  * [f16a0e7] New upstream version 1.1.0+dfsg1

 -- Anton Gladky <gladk@debian.org>  Sun, 03 Feb 2019 10:17:52 +0100

sumo (0.32.0+dfsg1-2) unstable; urgency=medium

  * [6b65aa2] Fix FTBFS with GCC-8. (Closes: #897872)
  * [a1ad134] Update VCS-field
  * [005fdea] Set Standards-Version to 4.2.0

 -- Anton Gladky <gladk@debian.org>  Mon, 27 Aug 2018 12:28:23 +0200

sumo (0.15.0~dfsg-1) unstable; urgency=low

  * Initial packaging in Debian. (Closes: #669160)

 -- Anton Gladky <gladky.anton@gmail.com>  Mon, 23 Apr 2012 19:17:01 +0200

sumo (0.14.0-1) unstable; urgency=low

  * New upstream release.

 -- Michael Behrisch <behrisch@users.sourceforge.net>  Thu, 12 Jan 2012 23:46:43 +0100

sumo (0.13.1-1) unstable; urgency=low

  * New upstream release.

 -- Michael Behrisch <behrisch@users.sourceforge.net>  Tue, 01 Nov 2011 10:24:24 +0100

sumo (0.13.0-1) unstable; urgency=low

  * New upstream release.

 -- Michael Behrisch <behrisch@users.sourceforge.net>  Wed, 13 Jul 2011 16:58:57 +0200

sumo (0.12.3-1) unstable; urgency=low

  * New upstream release.

 -- Michael Behrisch <behrisch@users.sourceforge.net>  Wed, 13 Apr 2011 19:28:57 +0200

sumo (0.10.2-1) unstable; urgency=low

  * New upstream release.

 -- Michael Behrisch <behrisch@informatik.hu-berlin.de>  Mon, 16 Mar 2009 22:00:47 +0100

sumo (0.10.1-1) unstable; urgency=low

  * Update

 -- Michael Behrisch <behrisch@informatik.hu-berlin.de>  Sun, 15 Feb 2009 22:34:33 +0200

sumo (0.9.10-1) unstable; urgency=low

  * Initial Release

 -- Michael Behrisch <behrisch@informatik.hu-berlin.de>  Thu, 23 Oct 2008 23:04:33 +0200

=== debian/control ===
Source: sumo
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11~),
               freeglut3-dev,
               help2man,
               libbz2-dev,
               libcups2-dev,
               libfox-1.6-dev,
               libgdal-dev,
               libgl2ps-dev,
               libproj-dev,
               libxerces-c-dev | libxerces-c2-dev,
               libxrandr-dev
Build-Depends-Indep: doxygen,
                     python,
                     python-matplotlib
Standards-Version: 4.2.0
Vcs-Browser: https://salsa.debian.org/science-team/sumo
Vcs-Git: https://salsa.debian.org/science-team/sumo.git
Homepage: http://sumo.dlr.de/

Package: sumo
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: sumo-tools
Description: Simulation of Urban MObility (SUMO)
 SUMO is an open source,
 highly portable, microscopic road traffic simulation package
 designed to handle large road networks.
 Main binary.

Package: sumo-doc
Architecture: all
Section: doc
Depends: libjs-underscore,
         ${misc:Depends}
Recommends: sumo
Description: Simulation of Urban MObility (SUMO), documentation and examples
 SUMO is an open source,
 highly portable, microscopic road traffic simulation package
 designed to handle large road networks.
 The binary contatins documentation and examples.

Package: sumo-tools
Architecture: all
Depends: jarwrapper,
         libjs-openlayers,
         python,
         python3,
         ${misc:Depends}
Recommends: sumo
Description: Simulation of Urban MObility (SUMO), tools and scripts
 SUMO is an open source,
 highly portable, microscopic road traffic simulation package
 designed to handle large road networks.
 The binary contatins different tools and scripts.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

no_hardening_all_archs = mips mipsel

ifeq (,$(filter $(DEB_HOST_ARCH),$(no_hardening_all_archs)))
  export DEB_BUILD_MAINT_OPTIONS = hardening=+all
endif

DPKG_EXPORT_BUILDFLAGS = 1

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export LIBS := -lgl2ps -lGL -lGLU -lglut

include /usr/share/dpkg/buildflags.mk

override_dh_auto_configure:
	dh_auto_configure -- --prefix=/usr

override_dh_auto_build-indep:
	$(MAKE) doxygen
	$(MAKE) pydoc
	#Clean some unneeded files and fix permissions
	find ./tools -name '*.pyc' -print0 | xargs -0 rm -f
	rm -rf ./tools/contributed/traci4j/COPYING
	rm -rf ./tools/contributed/trafficmodeler/src/resources/icons/Thumbs.db
	rm -rf ./tools/contributed/traci4j/.gitignore
	rm -rf ./tools/contributed/traas/license.txt
	rm -rf ./tools/contributed/traas/javadoc
	rm -rf ./tools/contributed/traci4matlab/license.txt
	rm -rf ./tools/contributed/trafficmodeler/LICENSE.txt
	rm -rf ./tools/webWizard/index.html
	rm -rf ./tools/game/sounds/license.txt

override_dh_auto_build-arch:
	dh_auto_build -a
	$(MAKE) man

override_dh_auto_install:
	dh_auto_install
	find . -type d -name "__pycache__" -delete

override_dh_auto_test-arch:
	mkdir $(CURDIR)/tests_auto
	cd $(CURDIR)/tests_auto; cp ../docs/examples/sumo/hokkaido/* ./; ../bin/sumo -b 0 -e 10000 -n net.net.xml -r input_routes.rou.xml -c hokkaido.sumocfg  --summary-output sum.out
	cat $(CURDIR)/tests_auto/sum.out
	rm -rf $(CURDIR)/tests_auto

=== debian/watch ===
version=3
opts=repacksuffix=+dfsg1,uuversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,dversionmangle=s/\+(debian|dfsg|ds|deb|-dfsg)\d*$// \
http://sf.net/sumo/sumo-src-([\d.]+)\.tar\.gz debian uupdate

## sumo 1.4.0%2Bdfsg1

=== src/dfrouter/CMakeLists.txt ===
set(dfrouter_SRCS
   dfrouter_main.cpp
   RODFDetFlowLoader.cpp
   RODFDetFlowLoader.h
   RODFDetector.cpp
   RODFDetector.h
   RODFDetectorFlow.cpp
   RODFDetectorFlow.h
   RODFDetectorHandler.cpp
   RODFDetectorHandler.h
   RODFNet.cpp
   RODFNet.h
   RODFRouteCont.cpp
   RODFRouteCont.h
   RODFRouteDesc.h
   RODFEdgeBuilder.cpp
   RODFEdgeBuilder.h
   RODFEdge.cpp
   RODFEdge.h
   RODFFrame.cpp
   RODFFrame.h
)

add_executable(dfrouter ${dfrouter_SRCS})
set_target_properties(dfrouter PROPERTIES OUTPUT_NAME dfrouter${BINARY_SUFFIX})
set_target_properties(dfrouter PROPERTIES OUTPUT_NAME_DEBUG dfrouter${BINARY_SUFFIX}D)
target_link_libraries(dfrouter router ${commonvehiclelibs})
add_dependencies(dfrouter generate-version-h)

install(TARGETS dfrouter RUNTIME DESTINATION bin)

=== src/guisim/CMakeLists.txt ===

########### next target ###############

SET(guisim_STAT_SRCS
   GUIBusStop.cpp
   GUIBusStop.h
   GUIContainer.cpp
   GUIContainer.h
   GUIContainerStop.cpp
   GUIContainerStop.h
   GUIParkingArea.cpp
   GUIParkingArea.h
   GUIDetectorWrapper.cpp
   GUIDetectorWrapper.h
   GUIE2Collector.cpp
   GUIE2Collector.h
   GUIE3Collector.cpp
   GUIE3Collector.h
   GUIEdge.cpp
   GUIEdge.h
   GUIEventControl.cpp
   GUIEventControl.h
   GUIInductLoop.cpp
   GUIInductLoop.h
   GUIInstantInductLoop.cpp
   GUIInstantInductLoop.h
   GUIJunctionWrapper.cpp
   GUIJunctionWrapper.h
   GUILane.cpp
   GUILane.h
   GUILaneSpeedTrigger.cpp
   GUILaneSpeedTrigger.h
   GUIPerson.cpp
   GUIPerson.h
   GUINet.cpp
   GUINet.h
   GUITrafficLightLogicWrapper.cpp
   GUITrafficLightLogicWrapper.h
   GUITriggeredRerouter.cpp
   GUITriggeredRerouter.h
   GUICalibrator.cpp
   GUICalibrator.h
   GUIChargingStation.cpp
   GUIChargingStation.h
   GUIBaseVehicle.cpp
   GUIBaseVehicle.h
   GUIVehicle.cpp
   GUIVehicle.h
   GUIVehicleControl.cpp
   GUIVehicleControl.h
   GUITransportableControl.cpp
   GUITransportableControl.h
)

add_library(guisim STATIC ${guisim_STAT_SRCS})
set_property(TARGET guisim PROPERTY PROJECT_LABEL "z_guisim")


########### install files ###############




#original Makefile.am contents follow:

#noinst_LIBRARIES = libguisim.a
#
#libguisim_a_SOURCES = GUIBusStop.cpp GUIBusStop.h \
#GUIContainer.cpp GUIContainer.h \
#GUIContainerStop.cpp GUIContainerStop.h \
#GUIParkingArea.cpp GUIParkingArea.h \
#GUIDetectorWrapper.cpp GUIDetectorWrapper.h \
#GUIE2Collector.cpp GUIE2Collector.h \
#GUIE3Collector.cpp GUIE3Collector.h GUIEdge.cpp GUIEdge.h \
#GUIEventControl.cpp GUIEventControl.h \
#GUIInductLoop.cpp GUIInductLoop.h \
#GUIInstantInductLoop.cpp GUIInstantInductLoop.h \
#GUIJunctionWrapper.cpp GUIJunctionWrapper.h \
#GUILane.cpp GUILane.h \
#GUILaneSpeedTrigger.cpp GUILaneSpeedTrigger.h \
#GUIPerson.cpp GUIPerson.h \
#GUINet.cpp GUINet.h \
#GUITrafficLightLogicWrapper.cpp GUITrafficLightLogicWrapper.h \
#GUITriggeredRerouter.cpp GUITriggeredRerouter.h \
#GUICalibrator.cpp GUICalibrator.h \
#GUIChargingStation.cpp GUIChargingStation.h \
#GUIBaseVehicle.cpp GUIBaseVehicle.h \
#GUIVehicle.cpp GUIVehicle.h GUIVehicleControl.cpp GUIVehicleControl.h \
#GUITransportableControl.cpp GUITransportableControl.h
#
#EXTRA_DIST = guisim64.ico
#

=== src/netload/CMakeLists.txt ===

########### next target ###############

SET(netload_STAT_SRCS
   NLDetectorBuilder.h
   NLDetectorBuilder.cpp
   NLDiscreteEventBuilder.h
   NLDiscreteEventBuilder.cpp
   NLEdgeControlBuilder.h
   NLEdgeControlBuilder.cpp
   NLJunctionControlBuilder.h
   NLJunctionControlBuilder.cpp
   NLBuilder.h
   NLBuilder.cpp
   NLHandler.h
   NLHandler.cpp
   NLTriggerBuilder.h
   NLTriggerBuilder.cpp
)

add_library(netload STATIC ${netload_STAT_SRCS})
set_property(TARGET netload PROPERTY PROJECT_LABEL "z_netload")


########### install files ###############




#original Makefile.am contents follow:

#noinst_LIBRARIES = libnetload.a
#
#libnetload_a_SOURCES = NLDetectorBuilder.h NLDetectorBuilder.cpp \
#NLDiscreteEventBuilder.h NLDiscreteEventBuilder.cpp \
#NLEdgeControlBuilder.h NLEdgeControlBuilder.cpp \
#NLJunctionControlBuilder.h NLJunctionControlBuilder.cpp \
#NLBuilder.h NLBuilder.cpp \
#NLHandler.h NLHandler.cpp \
#NLTriggerBuilder.h NLTriggerBuilder.cpp

=== src/traci_testclient/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,15 @@
 target_link_libraries(TraCITestClient utils_traci ${commonlibs})
 
 add_executable(testlibsumo testlibsumo_main.cpp)
+set_property(TARGET testlibsumo PROPERTY FOLDER "test_exe")
 set_target_properties(testlibsumo PROPERTIES OUTPUT_NAME testlibsumo${BINARY_SUFFIX})
 set_target_properties(testlibsumo PROPERTIES OUTPUT_NAME_DEBUG testlibsumo${BINARY_SUFFIX}D)
-target_link_libraries(testlibsumo ${sumolibs} traciserver microsim_cfmodels microsim_devices microsim_lcmodels microsim_output)
+target_link_libraries(testlibsumo libsumoc)
+add_test(libsumotest ${CMAKE_SOURCE_DIR}/bin/testlibsumo)
+
+add_executable(testlibsumostatic testlibsumo_main.cpp)
+set_property(TARGET testlibsumostatic PROPERTY FOLDER "test_exe")
+set_target_properties(testlibsumostatic PROPERTIES OUTPUT_NAME testlibsumostatic${BINARY_SUFFIX})
+set_target_properties(testlibsumostatic PROPERTIES OUTPUT_NAME_DEBUG testlibsumostatic${BINARY_SUFFIX}D)
+target_link_libraries(testlibsumostatic libsumostatic ${sumolibs} traciserver microsim_cfmodels microsim_devices microsim_engine microsim_output)
+add_test(libsumostatictest ${CMAKE_SOURCE_DIR}/bin/testlibsumostatic)

=== src/microsim/devices/CMakeLists.txt ===
set(microsim_devices_STAT_SRCS
   MSDevice.cpp
   MSDevice.h
   MSDevice_SSM.cpp
   MSDevice_SSM.h
   MSDevice_DriverState.cpp
   MSDevice_DriverState.h
   MSDevice_ToC.cpp
   MSDevice_ToC.h
   MSDevice_BTreceiver.cpp
   MSDevice_BTreceiver.h
   MSDevice_BTsender.cpp
   MSDevice_BTsender.h
   MSDevice_Emissions.cpp
   MSDevice_Emissions.h
   MSDevice_Transportable.cpp
   MSDevice_Transportable.h
   MSDevice_Routing.cpp
   MSDevice_Routing.h
   MSDevice_Tripinfo.cpp
   MSDevice_Tripinfo.h
   MSDevice_Battery.cpp
   MSDevice_Battery.h
   MSDevice_Example.cpp
   MSDevice_Example.h
   MSDevice_Vehroutes.cpp
   MSDevice_Vehroutes.h
   MSDevice_Bluelight.cpp
   MSDevice_Bluelight.h
   MSDevice_FCD.cpp
   MSDevice_FCD.h
   MSTransportableDevice.h
   MSTransportableDevice_Routing.cpp
   MSTransportableDevice_Routing.h
   MSTransportableDevice_FCD.cpp
   MSTransportableDevice_FCD.h
   MSRoutingEngine.cpp
   MSRoutingEngine.h
   MSVehicleDevice.h
)

add_library(microsim_devices STATIC ${microsim_devices_STAT_SRCS})
set_property(TARGET microsim_devices PROPERTY PROJECT_LABEL "z_microsim_devices")

=== src/microsim/output/CMakeLists.txt ===
set(microsim_output_STAT_SRCS
   MSCrossSection.h
   MSDetectorControl.cpp
   MSDetectorControl.h
   MSDetectorFileOutput.h
   MSE2Collector.cpp
   MSE2Collector.h
   MSE3Collector.cpp
   MSE3Collector.h
   MSInductLoop.cpp
   MSInductLoop.h
   MSInstantInductLoop.cpp
   MSInstantInductLoop.h
   MSMeanData.cpp
   MSMeanData.h
   MSMeanData_Emissions.cpp
   MSMeanData_Emissions.h
   MSMeanData_Harmonoise.cpp
   MSMeanData_Harmonoise.h
   MSMeanData_Net.cpp
   MSMeanData_Net.h
   MSMeanData_Amitran.cpp
   MSMeanData_Amitran.h
   MSRouteProbe.cpp
   MSRouteProbe.h
   MSVTypeProbe.cpp
   MSVTypeProbe.h
   MSXMLRawOut.cpp
   MSXMLRawOut.h
   MSFCDExport.cpp
   MSFCDExport.h
   MSAmitranTrajectories.cpp
   MSAmitranTrajectories.h
   MSBatteryExport.cpp
   MSBatteryExport.h
   MSStopOut.cpp
   MSStopOut.h
   MSEmissionExport.cpp
   MSEmissionExport.h
   MSVTKExport.cpp
   MSVTKExport.h
   MSFullExport.cpp
   MSFullExport.h
   MSQueueExport.cpp
   MSQueueExport.h
)

add_library(microsim_output STATIC ${microsim_output_STAT_SRCS})
set_property(TARGET microsim_output PROPERTY PROJECT_LABEL "z_microsim_output")

=== src/utils/router/CMakeLists.txt ===
set(utils_router_STAT_SRCS
   AStarLookupTable.h
   AStarRouter.h
   AccessEdge.h
   CarEdge.h
   PedestrianEdge.h
   PublicTransportEdge.h
   StopEdge.h
   CHBuilder.h
   CHRouter.h
   CHRouterWrapper.h
   DijkstraRouter.h
   IntermodalEdge.h
   IntermodalNetwork.h
   IntermodalRouter.h
   IntermodalTrip.h
   EffortCalculator.h
   GawronCalculator.h
   LogitCalculator.h
   RouteCostCalculator.h
   PedestrianRouter.h
   RouterProvider.h
   SUMOAbstractRouter.h
   SPTree.h
   FareModul.h
   FareToken.h
   FareZones.h)

if (MSVC)
    add_custom_target(z_utils_router SOURCES ${utils_router_STAT_SRCS})
endif()

=== src/utils/gui/globjects/CMakeLists.txt ===
set(utils_gui_globjects_STAT_SRCS
   GLIncludes.h
   GUIGLObjectPopupMenu.cpp
   GUIGLObjectPopupMenu.h
   GUIGlObject.cpp
   GUIGlObject.h
   GUIGlObjectStorage.cpp
   GUIGlObjectStorage.h
   GUIGlObjectTypes.h
   GUIGlObject_AbstractAdd.cpp
   GUIGlObject_AbstractAdd.h
   GUIShapeContainer.cpp
   GUIShapeContainer.h
   GUIPointOfInterest.cpp
   GUIPointOfInterest.h
   GUIPolygon.cpp
   GUIPolygon.h
)

add_library(utils_gui_globjects STATIC ${utils_gui_globjects_STAT_SRCS})
set_property(TARGET utils_gui_globjects PROPERTY PROJECT_LABEL "z_utils_gui_globjects")
